	//  File : default.cc
	//
	//  Example of default parameters in C++
	//
	#include <iostream.h>
	//
	// Function prototypes
	//
	//
	int simple(int a, int b, char operation='a');
	// ---------------------------^^^^^^^^^^^^^  Default values
	//
	int something(int a=0, int b=0, char operation='a');
	// ---------------^^^------^^^-------^^^^^^^^^^^^^  Default Values
	//
	void main()
	{
		cout << "The value of simple(5,5) = " 
			<< simple(5,5)<< endl;

		cout <<"The value of simple(10,5,'m') = " 
			<<simple (10,5,'m') << endl;

		cout << "The value of something() = " 
			<< something() << endl;
	
		cout << "The value of something(5,5) = "
			<<something(5,5) << endl;
		
	}
	// simple is a function with one default parameter
	//    the variable operation defaults to 'a'
	//
	int simple(int a, int b, char operation)
	{	if (operation=='a')
			return ( a + b );  // operation a for add
		else
			return (a - b );  // operation anything else subtract.
	}
	// something is a function with all three default paramters
	//  
	int something(int a, int b, char operation)
	{	if (operation='a')
			return ( a + b );  // operation a for add
		else
			return (a - b );  // operation anything else subtract.
	}
