// file : Dimen.h
//
// Dimention class
//
#include <iostream.h>
//
//      Dimention
//         Store dimention information for an object.
//
class Dimention
{       
	int hhight,wwidth;       // Hight & Width Dimentions
	int wweight;             // Weight

	public:
	// Access Functions
	//        
	//
	int hight() { return ((int) hhight); }
	int width() { return ((int) wwidth); }
	int weight() { return ((int) wweight); }
	
	// Access Functions
	//        to set or zero out the object
	//
	void zero();
	void set(const int new_width, const int new_hight);
	void set(const int new_width, const int new_hight, const int weight);
	friend ostream& operator<< (ostream& s, const Dimention& d);
	void set_hight(const int new_hight) { hhight=new_hight; }
	void set_weight(const int new_weight) { wweight=new_weight; }
	void set_width(const int new_width) { wwidth=new_width; }

	// Overloaded Constructors
	// for various amounts of information.

	Dimention() :
		hhight(0) ,
		wwidth(0) ,
		wweight(0)
		{}
	Dimention(int hight, int width) :
		hhight(hight) ,
		wwidth(width) ,
		wweight(0)
		{}
	Dimention(int hight, int width, int weight) :
		hhight(hight) ,
		wwidth(width) ,
		wweight(weight)
		{}
	
	//      Assignment operator
	//
	Dimention& operator= (const Dimention& source);
	
	//      For Multiplication and Division Assigments
	//
	Dimention& operator*= (const int scale);
	Dimention& operator/= (const int scale);

};
// Access funtions defined

inline void Dimention::zero() 
	{ hhight=0; wwidth=0; wweight=0; };

inline void Dimention::set(const int new_hight, const int new_width) 
	{ hhight=new_hight; wwidth=new_width; };

inline void Dimention::set(const int new_hight, const int new_width,
		 const int new_weight) 
	{ hhight=new_hight; wwidth=new_width; wweight=new_weight; };


// Operator functions for Dimention defined
//
//      Assignment operator '='
//
inline Dimention& Dimention::operator= (const Dimention& source)
{       hhight = source.hhight;
	wwidth = source.wwidth;
	wweight= source.wweight;
	return *this;
};
//
//      Assginment and Multiplication '*='
//
inline Dimention& Dimention::operator*= (const int scale)
{       hhight *= scale;
	wwidth *= scale;
	wweight*= scale;
	return *this;
};
//
//      Assginment and Division '/='
//
inline Dimention& Dimention::operator/= (const int scale)
{       hhight /= scale;
	wwidth /= scale;
	wweight/= scale;
	return *this;
};
//
//      << Operator to print Dimentions in a readable manner.
//
ostream& operator<< (ostream& s, const Dimention& d)
{       return s << "The Dimentions are "  << d.hhight << " high by " 
		 << d.wwidth << " wide and "
		 << d.wweight << " weight" ;
}



