//
//  File: menu3.cc
//
//      2nd try at a mouse driven Vertical menu
//
#include "window.h"
Pointer mouse;
class MenuItem : public Button
{       public :
                MenuItem(int no,int x1,int y1,int x2,int y2,
                                String lable,int hi,String fam="times"):
                        Button(x1,y1,x2,y2,lable,YES,YES,fam)
                {}
                MenuItem(String lable):
                        Button(0,0,0,0,"",NO,NO)
                { llable=lable; 
                  len=llable.length(); 
                }
                void fdraw()
                {     if (len>0)
                        GrDrawString((char*)llable,len,
                                l_x, l_y, &op );
                }
                void upcolor() { 
                   op.txo_fgcolor.v=Wcp.char_in_menu;
                   op.txo_bgcolor.v=Wcp.menu;
                   this.fdraw(); 
                }
                void downcolor() {                 
                   op.txo_fgcolor.v=Wcp.menu;
                   op.txo_bgcolor.v=Wcp.char_in_menu;
                   this.fdraw(); 
                }
                virtual void locate(int x1,int y1,int x2,int y2)
                {  display=YES;
                   active=YES;
                   Button::locate(x1,y1,x2,y2);
                   this.upcolor();
                }
                virtual void action() {}
};

class MenuBar :  public Title_Bar
{  private :
         int menu_count,next_x1;
   public :
         ButtonList menu_list;
         inline void press(int x,int y) { menu_list.press(x,y); };
         void insert(MenuItem *in) 
         { menu_count++;
           in->locate(next_x1,yy1,-1,yy2);
           next_x1=in->x2()+(xx2-xx1)/SPACING;
           menu_list.insert(in);
         }
         inline Button *remove_first() 
         { return menu_list.remove_first();};
         void fdraw() 
         {      GrFilledBox(xx1,yy1,xx2,yy2,Wcp.menu);
                menu_list.fdraw();
         }
         MenuBar(): Title_Bar("Testing testing","times") 
                {menu_count=0;}
         void locate (int x1,int y1,int x2,int y2)
         {     Title_Bar::locate(x1,y1,x2,y2);
               next_x1=xx1+(xx2-xx1)/SPACING;
         }  
};
class MTwindow : public Twindow
{       public :
              MenuBar horz_menu;
              MTwindow(String name,String fam) : 
                Twindow(name,fam), 
                horz_menu()
              {  int iy1=window.iy1();
                 horz_menu.locate(window.ix1(),iy1,
                                   window.ix2(),window.iy2());  
                 window.add_iy1(horz_menu.y2()-iy1);
                 setup();
              }  
              void cdraw()
              { Twindow::cdraw();
                horz_menu.fdraw();
              }
              inline virtual int ix1() { return horz_menu.x1(); };
              inline virtual int iy1() { return horz_menu.y2()+1; };
};
class VertMenu : public MenuItem
{
   private :
         int menu_count,next_y1;
         ButtonList *parent;
         int vx1,vy1,vx2,vy2;
         int width,maxwidth;
         int px1,py1;
         GrContext *storage;
         int created;

   public :
         ButtonList menu_list;
         inline void attach(ButtonList *p)
         { parent=p;}
         void press(int x,int y) 
         { menu_list.press(x,y);
           undisplay(); 
           if (parent!=NULL)
                parent->press(x,y);
         }
         virtual void undisplay(void)
         {     
               GrBitBlt(NULL,vx1,vy1,
                         storage,0,0,vx2-vx1+1,vy2-vy1+1,
                         GrWRITE
                         );

         }
         virtual void display(void)
         {     
               GrBitBlt(storage,0,0,
                         NULL,vx1,vy1,vx2+1,vy2+1,
                         GrWRITE
                         );
               vfdraw();
         }
         void insert(MenuItem *in) 
         { menu_count++;
           in->locate(vx1,next_y1,-1,next_y1+FONTHEIGHT);
           next_y1+=FONTHEIGHT+FONTHEIGHT/SPACING;
           width=in->x2()-in->x1();
           if ( width>maxwidth )
                maxwidth=width;
           menu_list.insert(in);
         }
         VertMenu(String lable,int x1=1,int y1=2): MenuItem(lable) 
         {  px1=x1;
            py1=y1;
            parent=NULL;
            maxwidth=0;
            created=FALSE;
         }  
         ~VertMenu()
         {  if (created)
            {  
               GrDestroyContext(storage);
            }
         }
         virtual void action()
         {      display();
                MouseGetEvent((M_BUTTON_DOWN),&mouse.evt);
                press(mouse.evt.x,mouse.evt.y);
         }
         void locate(int x1,int y1,int x2, int y2)
         {    MenuItem::locate(x1,y1,x2,y2);
              if (py1==1) vy1=yy1; else vy1=yy2;
              if (px1==1) vx1=xx1; else vx1=xx2;
              next_y1=vy1+FONTHEIGHT/SPACING;
         }
         void vlocate ()
         {      vx2=vx1+maxwidth+maxwidth/SPACING;
                vy2=next_y1;
                if (!created)
                {  
                   storage=GrCreateContext(vx2-vx1+2,vy2-vy1+2,NULL,NULL);
                   created=TRUE;
                }
         }  
         void vfdraw() 
         {      GrFilledBox(vx1,vy1,vx2,vy2,Wcp.menu);
                menu_list.fdraw();
         }
        
};

main()
{
      char buffer[30];
      
      if (initialize()==SUCESS)
      {  
         if (mouse.ok==SUCESS)
         {   MTwindow mw("Dummy","cour");
            
             // Main Horizontal Menu

             VertMenu file("File");
             file.attach(&mw.horz_menu.menu_list);
             VertMenu option("Option");
             option.attach(&mw.horz_menu.menu_list);
             MenuItem exit_option("Exit");
             mw.horz_menu.insert(&file);    
             mw.horz_menu.insert(&option);    
             mw.horz_menu.insert(&exit_option);

             //  File Menu

             MenuItem new_option("New");
             VertMenu open("Open",2,1);
             open.attach(&file.menu_list);
             MenuItem save("Save");
             file.insert(&new_option);
             file.insert(&open);
             file.insert(&save);
             file.vlocate();

             // Open Menu

             MenuItem test_item("Testing Long Item Name");
             MenuItem another("Another Item");
             MenuItem misc("Misc");
             open.insert(&test_item);
             open.insert(&another);
             open.insert(&misc);
             open.vlocate();

             // Option Menu

             MenuItem defaults("Defaults");
             MenuItem lark("Just a Lark");
             option.insert(&defaults);
             option.insert(&lark);
             option.vlocate();

             mw.cdraw();

             mw.print("Press a button\n");
           for (int i=15 ;i>0;i--)
           {   MouseGetEvent(( M_BUTTON_DOWN ),&mouse.evt);
               mw.horz_menu.press(mouse.evt.x,mouse.evt.y);
               sprintf(buffer,"Count = %d\n",i);
               mw.print(buffer);
           }
           
         }
      }
}
