// File:  box.cc
//
//   Example and the first try at a Graphic Class
//
#include <grx.h>
#include <mousex.h>
class Graphic
{
	static int initialized;
	static int count;
	public:
	
	Graphic()
	{  if (initialized==0)
	   {     GrSetMode(GR_biggest_noninterlaced_graphics); 
		initialized=1;
	   }
	   count++;
	}
	~Graphic()
	{  count--;
	   if (count==0)
		GrSetMode(GR_default_text);
	}
};
int Graphic::count=0;
int Graphic::initialized=0;
class FBox : public Graphic
{       
	protected:
	  int frame_width,xx,yy,width,height;
	  GrFBoxColors bc;
	  public:
	FBox() :
	  Graphic()
	{  
	   bc.fbx_intcolor = GrAllocColor(0,140,140);
	   bc.fbx_leftcolor = bc.fbx_topcolor = GrAllocColor(0,200,200);
	   bc.fbx_rightcolor = bc.fbx_bottomcolor = GrAllocColor(0,80,80);
	   frame_width=10;
	   xx=200;
	   yy=200;
	   width=20;
	   height=20;
	}

	int draw()
	{       GrFramedBox(xx,               // x1
			    yy,               // y1 
			    xx+width,         // x2
			    yy+height,        // y2
			    frame_width,                  
			    &bc               // colors
			    );
	}
};
main ()
{  FBox fbox;
   fbox.draw();
   getkey();
}
