//
//  File: twin1.cc
//
//      1st Try at a text window.  -with text.
//                                 -with print function & scrolling.
//
#include "window.h"
#define MAXLINES  60
#define DEFAULT_WIDTH 9
#define DEFAULT_HEIGHT 16
class Twindow : Box
{       private :
                GrTextRegion r;
                GrTextOption op;
                int rrow,ccol,maxrow,maxcol;
                String family;
                Window window;
                inline void set_c(int row,int col,char c)
                {   r.txr_buffer
                        [row*r.txr_lineoffset+col]=c;
                };
                inline char get_c(int row,int col)
                {   return (r.txr_buffer
                                [row*r.txr_lineoffset+col]);
                };
                setup()
                {  rrow=0;
                   ccol=0;
                   op.txo_fgcolor.v=Wcp.char_in_win;
                   op.txo_bgcolor.v=Wcp.window;
                   r.txr_font=op.txo_font;
                   int pixels_wide=window.ix2()-window.ix1();
                   int pixels_high=window.iy2()-window.iy1();
                   r.txr_width=pixels_wide/GrFontWidth(&op)-2;
                   r.txr_height=pixels_high/GrFontHeight(&op)-2;
                   maxrow=r.txr_height;
                   maxcol=r.txr_width;
                   r.txr_buffer=
                        new(char [(r.txr_height+1)*r.txr_width+1]);
                   r.txr_backup=
                        new(char [r.txr_height*r.txr_width+1]);
                   r.txr_lineoffset=r.txr_width;
                   r.txr_fgcolor.v=op.txo_fgcolor.v;
                   r.txr_bgcolor.v=op.txo_bgcolor.v;
                   r.txr_chrtype=GR_BYTE_TEXT;
                   r.txr_xpos=window.ix1()+
                                (pixels_wide-
                                 r.txr_width*GrFontWidth(&op))/2;
                   r.txr_ypos=window.iy1()+
                                (pixels_high-
                                 r.txr_height*GrFontHeight(&op))/2;
                  // initalize buffer to spaces
                  for (int i=0; i<(r.txr_height+1) ; i++)
                    for (int j=0; j<r.txr_width ; j++)
                          set_c(i,j,' ');
                }
        public :
                Twindow(String name,String fam) :
                  window(name),
                  family(fam)
                { if(NULL==GrFindBestFont(DEFAULT_WIDTH,
                                          DEFAULT_HEIGHT,0,
                                  (char *) family,
                                  &op )
                      )
                       mess_i("Null returned from GrFind",0);
                  this.setup();
                }         
                void cdraw()
                {       window.cdraw();
                        GrDumpTextRegion(&r);
                }
                void print(char c)
                { if (c=='\n')
                  { rrow++;
                    ccol=0;
                    if (rrow>maxrow)
                    {  for (int i=0; i<(maxrow);i++)
                       {   for (int j=0; j<maxcol ; j++)
                               set_c(i,j,get_c(i+1,j));
                       }
                    }
                    GrDumpTextRegion(&r);
                    return;
                  }
                  if (++ccol<maxcol)
                  {     set_c(rrow,ccol,c);       
                        GrDumpChar(c,ccol,rrow,&r);
                  }
                }
                void print(char *line)
                {    for (int i=0; i<strlen(line) ; i++)
                        this.print(line[i]);
                }
                void print(String line)
                {    this.print( (char *) line);
                }
}; 
main()
{     ifstream color_file("COLOR.DAT");
      ifstream pref_colors("PCOL.DAT");
      if (color_file && pref_colors)
      {
         color_file >> color_table;
         pref_colors>> Wcp;
         GrSetFontPath("C:\\DJGPP\\CONTRIB\\LIBGRX\\FONTS\\");  
         Twindow win("Test Window","cour");
         win.cdraw();
         win.print("This is the life\n");
         getkey();
         win.print('\n');
         win.print("More Stuff");
         getkey();
         for (int i=1;i<100;i++)
                win.print("You Betcha this is it\n");
         getkey();
      }
}
