//  Win3
//
//   Try 3 at windowing : Blank window & Title Bar with
//                        Appropreate sized bitmapped
//                        text.
#include "graphic.h"
#include "debug.h"
Color_Table color_table;
class Title_Bar : public Box
{
	protected: 
		int m_x,m_y;     // m=message
		String message;
		int len;
		GrTextOption op;
		GrFont *font;
	public:
		Title_Bar(int x1,int y1,int x2,int y2,
			  int fgc,int bgc,
			  char *m,char *fam) :
			message(m),
			Box(x1,y1,x2,y2,bgc)  
		{  int max_width,max_height;
		   int tot_width,tot_height;
		   len=message.length();
		   max_width=(x2-x1)/len;
		   max_height=y2-y1;
		   if(NULL==GrFindBestFont(max_width,
				  max_height,
				  0,
				  fam,
				  &op )
		      )
		       mess_i("Null returned from GrFind",0);
		   op.txo_fgcolor.v=fgc;
		   op.txo_bgcolor.v=bgc;
		   tot_width=GrStringWidth(m,len,&op);
		   tot_height=GrStringHeight(m,len,&op);
		   m_x=x1+(x2-x1-tot_width)/2;
		   m_y=y1+(y2-y1-tot_height)/2;
		}
		void cdraw()
		{  
		   GrSetContext(ccontext);
		   GrFilledBox(xx1,yy1,xx2,yy2,cc);
		   GrDrawString((char*)message,len,
				m_x, m_y, &op );
		}
		void fdraw()
		{  GrFilledBox(xx1,yy1,xx2,yy2,cc);
		   GrDrawString((char*)message,len,
				m_x, m_y, &op );
		}
};
class Window : public Box
{       protected :
		Title_Bar title;
	public :
	Window () :
	  Box(MaxX/4,
	      MaxY/4,
	      MaxX/4*3,
	      MaxY/4*3,
	      color_table.c("DK_BLUE")),
	  title(MaxX/4+1,
	      MaxY/4+1,
	      MaxX/4*3-1,
	      MaxY/4+1+MaxY/12,
	      color_table.c("WHITE"),
	      color_table.c("GREEN"),
	      "Test Title Bar","times")
	{}           
	void cdraw()
	{  GrBox(xx1,yy1,xx2,yy2,cc);
	   title.cdraw();
	} 
};
main()
{     ifstream color_file("COLOR.DAT");
      if (color_file)
      {
	 color_file >> color_table;
	 GrSetFontPath("C:\\DJGPP\\CONTRIB\\LIBGRX\\FONTS\\");  
	 Window win;
	 win.cdraw();
	 getkey();
      }
}
