//  Win4
//
//   Try 4 at windowing : Framed, Filled window & 
//                        Title Bar with
//                        Appropreate sized bitmapped
//                        text.
//                        Using Prefered Color Setup.
#include "graphic.h"
#include "debug.h"
Color_Table color_table;
struct Win_Colors
{       int background;
	int window;
	int window_frame;
	int char_in_win;
	int scroll_bar;
	int menu;
	int char_in_menu;
	int active_title_bar;
	int inact_title_bar;
	int char_act_title;
	int char_ina_title;
	int popup_win;
	int char_in_popup;
	int message_window;
	int char_in_message;
	int button_face;
	int button_text;
	int button_shadow;
} Wcp;
//
//      >> Operator to read Win Colors.
//
istream& operator>> (istream& s, Win_Colors& Wcp)
{       String name,brace,color;

	s >> name;
	if (name!="Win_Colors")
		return s;
	s >> brace;
	if (brace!="{")
		return s;
do 
{ s >> name >> color;
  if (name=="background"     ) Wcp.background     =color_table.c(color);
  if (name=="window"         ) Wcp.window         =color_table.c(color);
  if (name=="window_frame"   ) Wcp.window_frame   =color_table.c(color);
  if (name=="char_in_win"    ) Wcp.char_in_win    =color_table.c(color);
  if (name=="scroll_bar"     ) Wcp.scroll_bar     =color_table.c(color);
  if (name=="menu"           ) Wcp.menu           =color_table.c(color);
  if (name=="char_in_menu"   ) Wcp.char_in_menu   =color_table.c(color);
  if (name=="active_title_bar") Wcp.active_title_bar=color_table.c(color);
  if (name=="inact_title_bar") Wcp.inact_title_bar=color_table.c(color);
  if (name=="char_act_title" ) Wcp.char_act_title =color_table.c(color);
  if (name=="char_ina_title" ) Wcp.char_ina_title =color_table.c(color);
  if (name=="popup_win"      ) Wcp.popup_win      =color_table.c(color);
  if (name=="char_in_popup"  ) Wcp.char_in_popup  =color_table.c(color);
  if (name=="message_window" ) Wcp.message_window =color_table.c(color);
  if (name=="char_in_message") Wcp.char_in_message=color_table.c(color);
  if (name=="button_face"    ) Wcp.button_face    =color_table.c(color);
  if (name=="button_text"    ) Wcp.button_text    =color_table.c(color);
  if (name=="button_shadow"  ) Wcp.button_shadow  =color_table.c(color);
} while (color!="END");
	s >> brace;
	return s;
}

class Title_Bar : public Box
{
	protected: 
		int m_x,m_y;     // m=message
		String message;
		int len;
		GrTextOption op;
		GrFont *font;
	public:
		Title_Bar(int x1,int y1,int x2,int y2,
			  int fgc,int bgc,
			  char *m,char *fam) :
			message(m),
			Box(x1,y1,x2,y2,bgc)  
		{  int max_width,max_height;
		   int tot_width,tot_height;
		   len=message.length();
		   max_width=(x2-x1)/len;
		   max_height=y2-y1;
		   if(NULL==GrFindBestFont(max_width,
				  max_height,
				  0,
				  fam,
				  &op )
		      )
		       mess_i("Null returned from GrFind",0);
		   op.txo_fgcolor.v=fgc;
		   op.txo_bgcolor.v=bgc;
		   tot_width=GrStringWidth(m,len,&op);
		   tot_height=GrStringHeight(m,len,&op);
		   m_x=x1+(x2-x1-tot_width)/2;
		   m_y=y1+(y2-y1-tot_height)/2;
		}
		void cdraw()
		{  
		   GrSetContext(ccontext);
		   GrFilledBox(xx1,yy1,xx2,yy2,cc);
		   GrDrawString((char*)message,len,
				m_x, m_y, &op );
		}
		void fdraw()
		{  GrFilledBox(xx1,yy1,xx2,yy2,cc);
		   GrDrawString((char*)message,len,
				m_x, m_y, &op );
		}
};
class Window : public Box
{       protected :
		Title_Bar title;
		GrFBoxColors win_frame_c;
	public :
	Window () :
	  Box(MaxX/4,
	      MaxY/4,
	      MaxX/4*3,
	      MaxY/4*3,
	      Wcp.window_frame),
	  title(MaxX/4+1,
	      MaxY/4+1,
	      MaxX/4*3-1,
	      MaxY/4+1+MaxY/30,
	      Wcp.char_act_title,
	      Wcp.active_title_bar,
	      "Test Title Bar","times")
	{    win_frame_c.fbx_intcolor=Wcp.window;
	     win_frame_c.fbx_topcolor=Wcp.window_frame;
	     win_frame_c.fbx_bottomcolor=Wcp.window_frame;
	     win_frame_c.fbx_leftcolor=Wcp.window_frame;
	     win_frame_c.fbx_rightcolor=Wcp.window_frame;
	}           
	void cdraw()
	{  GrFramedBox(xx1,yy1,xx2,yy2,MaxX/100,&win_frame_c);
	   title.cdraw();
	} 
};
main()
{     ifstream color_file("COLOR.DAT");
      ifstream pref_colors("PCOL.DAT");
      if (color_file && pref_colors)
      {
	 color_file >> color_table;
	 pref_colors>> Wcp;
	 GrSetFontPath("C:\\DJGPP\\CONTRIB\\LIBGRX\\FONTS\\");  
	 GrClearScreen(Wcp.background);
	 Window win;
	 win.cdraw();
	 getkey();
      }
}
